package control;

import javafx.event.*;
import javafx.scene.input.*;
import model.ManModel;
import model.Model;
import view.View;

public class ControllerKeyboard implements EventHandler<KeyEvent> {

    protected Model model;
    protected View view;
    protected Controller control;

    public ControllerKeyboard(Model model, View view, Controller control) {
        this.model = model;
        this.view = view;
        this.control = control;
        // Attach KeyEvent listening to a Node that has focus.
        view.getRootPane().setFocusTraversable(true);
        view.getRootPane().requestFocus();
        view.getRootPane().setOnKeyPressed(this);
        view.getRootPane().setOnKeyReleased(this);

    }

    public void handle(KeyEvent arg0) {

        if (arg0.getEventType() == KeyEvent.KEY_RELEASED) {
            // if the key is not in the keyPressed (cf. Model)
            // removeKeyPressed will do nothing
            model.removeKeyPressed(arg0.getCode().getName());
        }
        else if (arg0.getEventType() == KeyEvent.KEY_PRESSED) {
            if ( (arg0.getCode() == KeyCode.LEFT) ||
                    (arg0.getCode() == KeyCode.RIGHT) ||
                    (arg0.getCode() == KeyCode.SPACE)) {
                model.addKeyPressed(arg0.getCode().getName());
            }
            else if (arg0.getCode() == KeyCode.S) {
                System.out.println("starting animation");
                control.startAnimation();
            } else if (arg0.getCode() == KeyCode.BACK_SPACE) {
                control.stopAnimation();
                control.step();
            }
        }
    }
}
